=== include/CMakeLists.txt ===
add_subdirectory(cgreen)
