=== samples/Makefile ===
sample: sample.o
	$(CC) -o sample sample.o -lcgreen
