=== include/cgreen/internal/CMakeLists.txt ===
set(cgreen_internal_HDRS
  unit_implementation.h
  mock_table.h
  mocks_internal.h
  suite_internal.h
  assertions_internal.h
  c_assertions.h
  cpp_assertions.h
  cgreen_pipe.h
  cgreen_time.h
  runner_platform.h
  function_macro.h
  stringify_token.h
)

install(
  FILES
    ${cgreen_internal_HDRS}
  DESTINATION
    ${CMAKE_INSTALL_INCLUDEDIR}/${APPLICATION_NAME}/internal
  COMPONENT
    headers
)
