=== debian/changelog ===
cgreen (1.6.3-1build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 11:40:42 +0200

cgreen (1.6.3-1) unstable; urgency=medium

  * Import new upstream release (Closes: #1038145)
  * Remove patch files which are fixed by upstream
  * Update symbols

 -- Gavin Lai (賴建宇) <gavin09@gmail.com>  Tue, 03 Oct 2023 23:11:21 +0800

cgreen (1.6.2-1~exp2) experimental; urgency=medium

  * d/rules:
    - Collect debug log when dh_auto_test fails

 -- Gavin Lai (賴建宇) <gavin09@gmail.com>  Sun, 24 Sep 2023 22:14:51 +0800

cgreen (1.6.2-1~exp1) experimental; urgency=medium

  * Import new upstream release
  * d/control:
    - Bump Standards-Version to 4.6.2
    - Remove libbdf-dev from build-deps (Closes: #1010589)
    - Add libxml2-dev to build-deps
    - Add Recommends libcgreen1-dev in cgreen1
  * Update symbols
  * Add a patch to fix man page error

 -- Gavin Lai (賴建宇) <gavin09@gmail.com>  Tue, 15 Aug 2023 23:18:11 +0800
