=== debian/tests/control ===
Tests: testsuite
Restrictions: allow-stderr, superficial
Depends: @
